#include "test/Test.hpp"
#include "tests/ArrayListTests.hpp"
#include "tests/ArrayStringTests.hpp"
#include "tests/ArrayTests.hpp"
#include "tests/BitArrayTests.hpp"
#include "tests/BoxTests.hpp"
#include "tests/BufferTests.hpp"
#include "tests/BufferedValueTests.hpp"
#include "tests/ClockTests.hpp"
#include "tests/ColorTests.hpp"
#include "tests/ComponentsTests.hpp"
#include "tests/FileReaderTests.hpp"
#include "tests/FrustumTests.hpp"
#include "tests/HashMapTests.hpp"
#include "tests/LinkedListTests.hpp"
#include "tests/ListTests.hpp"
#include "tests/MathTests.hpp"
#include "tests/MatrixStackTests.hpp"
#include "tests/MatrixTests.hpp"
#include "tests/PlaneTests.hpp"
#include "tests/ProbingHashMapTests.hpp"
#include "tests/QuaternionTests.hpp"
#include "tests/RandomTests.hpp"
#include "tests/RingBufferTests.hpp"
#include "tests/StackTests.hpp"
#include "tests/ThreadTests.hpp"
#include "tests/UniquePointerTests.hpp"
#include "tests/UtilityTests.hpp"
#include "tests/VectorTests.hpp"
#include "tests/ViewTests.hpp"
#include "utils/ArrayString.hpp"
#include "utils/Utility.hpp"

static void onExit(int code, void* data) {
    unsigned int i = *static_cast<unsigned int*>(data);
    Core::String32<1024> s;
    CORE_TEST_ERROR(s.append("Hello from exit #: #"));
    CORE_TEST_ERROR(s.format(code, i));
    CORE_TEST_ERROR(s.printLine());
    Core::Test::finalize();
}

int main() {
    Core::ArrayListTests::test();
    Core::ArrayStringTests::test();
    Core::ArrayTests::test();
    Core::BitArrayTests::test();
    Core::BoxTests::test();
    Core::BufferTests::test();
    Core::BufferedValueTests::test();
    Core::ClockTests::test();
    Core::ColorTests::test();
    Core::ComponentsTests::test();
    Core::FileReaderTests::test();
    Core::FrustumTests::test();
    Core::HashMapTests::test();
    Core::LinkedListTests::test();
    Core::ListTests::test();
    Core::MathTests::test();
    Core::MatrixStackTests::test();
    Core::MatrixTests::test();
    Core::PlaneTests::test();
    Core::ProbingHashMapTests::test();
    Core::QuaternionTests::test();
    Core::RandomTests::test();
    Core::RingBufferTests::test();
    Core::StackTests::test();
    Core::ThreadTests::test();
    Core::UniquePointerTests::test();
    Core::UtilityTests::test();
    Core::VectorTests::test();
    Core::ViewTests::test();

    unsigned int data = 123456789;
    Core::setExitHandler(onExit, &data);
    CORE_EXIT(1);

    return 0;
}
