#ifndef CORE_THREAD_HPP
#define CORE_THREAD_HPP

#include "utils/AlignedData.hpp"
#include "utils/Check.hpp"
#include "utils/Error.hpp"

namespace Core {
    class Thread {
        AlignedData<8, 8> thread;

    public:
        using Function = int (*)(void*);

        check_return Error start(Function f, void* p);
        check_return Error join(int* returnValue = nullptr);
    };
}

#endif